import * as tslib_1 from "tslib";
import { isLoaderRequestElement } from "../../../types";
import { ModulePrefix } from "../../../";
import ResolveRoute from "../../../util/ResolveRoute";
var buildCreated = function (loaderRequest, prefetchTest) {
    if (prefetchTest === void 0) { prefetchTest = false; }
    return function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var isPost, contentType, requests, _i, loaderRequest_1, request;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof loaderRequest === "string")) return [3 /*break*/, 2];
                        if (prefetchTest &&
                            this.$store.state[ModulePrefix + "_post"].types.pages &&
                            this.$store.state[ModulePrefix + "_post"].types.pages[ResolveRoute(loaderRequest, this.$route)]) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: ResolveRoute(loaderRequest, this.$route),
                                type: "pages",
                                embed: false
                            })];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 2:
                        if (!isLoaderRequestElement(loaderRequest)) return [3 /*break*/, 4];
                        isPost = "type" in loaderRequest;
                        contentType = isPost ? loaderRequest.type : "pages";
                        if (prefetchTest &&
                            this.$store.state[ModulePrefix + "_post"].types[contentType] &&
                            this.$store.state[ModulePrefix + "_post"].types[contentType][ResolveRoute(loaderRequest.slug, this.$route)]) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: ResolveRoute(loaderRequest.slug, this.$route),
                                type: contentType,
                                embed: loaderRequest.hasOwnProperty("embed")
                            })];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 4:
                        if (!Array.isArray(loaderRequest)) return [3 /*break*/, 6];
                        requests = [];
                        for (_i = 0, loaderRequest_1 = loaderRequest; _i < loaderRequest_1.length; _i++) {
                            request = loaderRequest_1[_i];
                            if (typeof request !== "string" && !isLoaderRequestElement(request)) {
                                throw new Error("FetchHookType Created: Bad loaderRequest");
                            }
                            requests.push(buildCreated.call(this, request).call(this));
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6: throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
};
export default buildCreated;
//# sourceMappingURL=Created.js.map